oyConversion_s Struct Reference
Description: C source code API documentation for the Oyranos project.
Keywords: Oyranos,Color Management,Color Management,ICC,CMS,C,doxygen,API,documentation

| Oyranos Color Management System API - Version 0.9.6

Public Member Functions | Data Fields
oyConversion_s Struct Reference
Conversion

A filter chain or graph to manipulate a image. More...

`#include <oyConversion_s.h>`

Inheritance diagram for oyConversion_s:
Collaboration diagram for oyConversion_s:

## Public Member Functions
OYAPI oyConversion_s *OYEXPORT | oyConversion_New (oyObject_s object)
| allocate a new Conversion object More...
| oyConversion_Copy
| Copy or Reference a Conversion object. More...
OYAPI int OYEXPORT | oyConversion_Release (oyConversion_s **conversion)
| release and possibly deallocate a oyConversion_s object More...
int | oyConversion_Correct (oyConversion_s *conversion, const char *registration, uint32_t flags, oyOptions_s *options)
| Check for correctly adhering to policies. More...
oyConversion_s * | oyConversion_CreateBasicPixels (oyImage_s *input, oyImage_s *output, oyOptions_s *options, oyObject_s object)
| Allocate initialise a basic oyConversion_s object. More...
oyConversion_s * | oyConversion_CreateBasicPixelsFromBuffers (oyProfile_s *p_in, oyPointer buf_in, oyPixel_t buf_type_in, oyProfile_s *p_out, oyPointer buf_out, oyPixel_t buf_type_out, oyOptions_s *options, int count)
| One dimensional color conversion context. More...
oyConversion_s * | oyConversion_CreateFromImage (oyImage_s *image_in, oyOptions_s *module_options, oyProfile_s *output_profile, oyDATATYPE_e buf_type_out, uint32_t flags, oyObject_s obj)
| generate a Oyranos graph from a image file name More...
oyFilterGraph_s * | oyConversion_GetGraph (oyConversion_s *conversion)
| Get the filter graph from a conversion context. More...
oyImage_s * | oyConversion_GetImage (oyConversion_s *conversion, uint32_t flags)
| Get a image copy at the desired position. More...
oyFilterNode_s * | oyConversion_GetNode (oyConversion_s *conversion, uint32_t flags)
| Get the filter node copy. More...
int | oyConversion_GetOnePixel (oyConversion_s *conversion, double x, double y, oyPixelAccess_s *pixel_access)
| Compute one pixel at the given position. More...
int | oyConversion_RunPixels (oyConversion_s *conversion, oyPixelAccess_s *pixel_access)
| Iterate over a conversion graph. More...
int | oyConversion_Set (oyConversion_s *conversion, oyFilterNode_s *input, oyFilterNode_s *output)
| Set input and output of a conversion graph. More...
char * | oyConversion_ToText (oyConversion_s *conversion, const char *head_line, int reserved, oyAlloc_f allocateFunc)
| Text description of a conversion graph. More...
Public Member Functions inherited from oyStruct_s
const char * | oyStruct_GetTextFromModule (oyStruct_s *obj, oyNAME_e name_type, uint32_t flags)
| get object infos from a module More...
const char * | oyStruct_GetText (oyStruct_s *obj, oyNAME_e name_type, uint32_t flags)
| Get a text dump. More...
| oyStruct_RegisterStaticMessageFunc
| register a function for verbosity More...
| oyStruct_GetInfo
| get a additional string from a object More...
const char * | oyStructTypeToText (oyOBJECT_e type)
| Objects type to small string. More...

## Data Fields
const oyOBJECT_e | type_
| Type of object. More...
oyStruct_Copy_f | copy
| Copy function. More...
oyStruct_Release_f | release
| Release function. More...
oyObject_s | oy_
| Oyranos internal object. More...
Data Fields inherited from oyStruct_s
const oyOBJECT_e | type_
| Type of object. More...
oyStruct_Copy_f | copy
| Copy function. More...
oyStruct_Release_f | release
| Release function. More...
oyObject_s | oy_
| Oyranos internal object. More...

## Detailed Description

A filter chain or graph to manipulate a image.

Order of filters matters. The processing direction is a bit like raytracing as nodes request their parent.

The graph is allowed to be a directed graph without cycles.

oyConversion_s shall provide access to the graph and help in processing and managing nodes.

Creating Graphs:
Most simple is to use the oyConversion_CreateBasicPixels() function to create a profile to profile and possible image buffer to image buffer linear graph.
The other possibility is to create a non linear graph. The input member can be accessed for this directly.

While it would be possible to have several open ends in a graph, there are two endpoints considered as special. The input member prepresents the top most required node to be provided in a oyConversion_s graph. The input node is accessible for user manipulation. The other one is the out_ member. It is the closing node in the graph. It will be set by Oyranos during closing the graph.

Using Graphs:
To obtain the data the oyConversion_RunPixels() and oyConversion_GetOnePixel() functions are available.

Version
  Oyranos: 0.1.8

Since
  2008/06/08 (Oyranos: 0.1.8)

Date
  2008/06/08

Examples:
  image2pdf.c, image_display.cpp, and tutorial1.c.

## Member Function Documentation

## ◆ oyConversion_Copy()

oyConversion_Copy

Copy or Reference a Conversion object.

The function is for copying and for referencing. The reference is the most often used way, which saves resourcs and time.

Parameters

  [in] | conversion | Conversion struct object
  | object | NULL - means reference, the optional object triggers a real copy

## ◆ oyConversion_Correct()

int oyConversion_Correct | ( | oyConversion_s * | conversion,
|  | const char * | registration,
|  | uint32_t | flags,
|  | oyOptions_s * | options
| ) |  |

Check for correctly adhering to policies.

Function oyConversion_Correct

Without any options the module selected with the Registration policy filter shall perform graph analysis and correct the graph.

Typical Options:
  - "command"-"help" - a string option issuing a help text as message
  - "verbose" - reporting changes as message

TODO: display and selection of policy modules

See also
  Defaults Handling

Parameters

  | conversion | the to be checked configuration
  | registration | the to be used policy module
  [in] | flags | for inbuild defaults | oyOPTIONSOURCE_FILTER; for options marked as advanced | oyOPTIONATTRIBUTE_ADVANCED | OY_SELECT_FILTER | OY_SELECT_COMMON
  | options | options to the policy module

Returns
  0 - indifferent, >= 1 - error
  - a message should be sent

Version
  Oyranos: 0.9.6

Date
  2014/06/26

Since
  2009/07/24 (Oyranos: 0.1.10)

Examples:
  image2pdf.c.

## ◆ oyConversion_CreateBasicPixels()

oyConversion_s * oyConversion_CreateBasicPixels | ( | oyImage_s * | input,
|  | oyImage_s * | output,
|  | oyOptions_s * | options,
|  | oyObject_s | object
| ) |  |

Allocate initialise a basic oyConversion_s object.

Function oyConversion_CreateBasicPixels

Provided options will be passed to oyFilterNode_NewWith(). There for no options defaults will be selected.

Parameters

  [in] | input | the input image data
  [in] | output | the output image data
  [in] | options | options to be passed to oyFilterCore_s Each option should be carefully named to be correctly selected by the intented filter (root, icc and output). The available options are particial defined by plugable policy modules, e.g. "oicc", and a filters own options. OY_DEFAULT_CMM_CONTEXT and OY_DEFAULT_CMM_RENDERER can contain string to explicitely select the icc module.
  | object | the optional object

Returns
  the conversion context

Version
  Oyranos: 0.9.6

Date
  2014/06/29

Since
  2008/06/26 (Oyranos: 0.1.8)

Examples:
  image2pdf.c.

References OY_CMM_STD, OY_TYPE_STD, oyConversion_New(), oyConversion_Release(), oyConversion_Set(), oyFilterNode_s::oyFilterNode_Connect(), oyFilterNode_s::oyFilterNode_FromOptions(), oyFilterNode_s::oyFilterNode_NewWith(), and oyFilterNode_s::oyFilterNode_SetData().

Referenced by oyConversion_CreateBasicPixelsFromBuffers().

## ◆ oyConversion_CreateBasicPixelsFromBuffers()

oyConversion_s * oyConversion_CreateBasicPixelsFromBuffers | ( | oyProfile_s * | p_in,
|  | oyPointer | buf_in,
|  | oyPixel_t | buf_type_in,
|  | oyProfile_s * | p_out,
|  | oyPointer | buf_out,
|  | oyPixel_t | buf_type_out,
|  | oyOptions_s * | options,
|  | int | count
| ) |  |

One dimensional color conversion context.

Function oyConversion_CreateBasicPixelsFromBuffers

The options are passed to oyConversion_CreateBasicPixels(); The function does the lookups for the profiles and the modules contexts in the Oyranos cache on the fly.

Parameters

  [in] | p_in | the input profile
  [in] | buf_in | the input channels
  [in] | buf_type_in | the input pixel type; channel count can be omitted
  [in] | p_out | the output profile
  [in] | buf_out | the output channels
  [in] | buf_type_out | the output pixel type; channel count can be omitted
  [in] | options | see the same option in oyConversion_CreateBasicPixels()
  [in] | count | the pixel count to convert in buf_in and buf_out

Returns
  the conversion context

Version
  Oyranos: 0.9.5

Date
  2014/02/05

Since
  2011/02/22 (Oyranos: 0.3.0)

Examples:
  tutorial1.c.

References oyChannels_m, oyConversion_CreateBasicPixels(), oyImage_s::oyImage_Create(), oyImage_s::oyImage_Release(), oyProfile_s::oyProfile_GetChannelsCount(), and oyToChannels_m.

## ◆ oyConversion_CreateFromImage()

oyConversion_s * oyConversion_CreateFromImage | ( | oyImage_s * | image_in,
|  | oyOptions_s * | module_options,
|  | oyProfile_s * | output_profile,
|  | oyDATATYPE_e | buf_type_out,
|  | uint32_t | flags,
|  | oyObject_s | obj
| ) |  |

generate a Oyranos graph from a image file name

Function oyConversion_CreateFromImage

Parameters

  [in] | image_in | input
  [in] | module_options | options for icc node
  [in] | output_profile | profile to convert colors to;
  [in] | buf_type_out | the desired data type for output
  [in] | flags | for inbuild defaults | oyOPTIONSOURCE_FILTER; for options marked as advanced | oyOPTIONATTRIBUTE_ADVANCED | OY_SELECT_FILTER | OY_SELECT_COMMON
  [in] | obj | Oyranos object (optional)

Returns
  generated new graph, owned by caller

Version
  Oyranos: 0.9.6

Date
  2014/07/01

Since
  2012/04/21 (Oyranos: 0.5.0)

## ◆ oyConversion_GetGraph()

oyFilterGraph_s * oyConversion_GetGraph | ( | oyConversion_s * | conversion | ) |

Get the filter graph from a conversion context.

Function oyConversion_GetGraph

See also
  oyFilterGraph_GetNode() to obtain a node.

Parameters

  [in,out] | conversion | conversion object

Returns
  the filter graph containing all nodes

Version
  Oyranos: 0.2.1

Since
  2011/01/02 (Oyranos: 0.2.1)

Date
  2011/01/02

References oyFilterGraph_s::oyFilterGraph_FromNode().

## ◆ oyConversion_GetImage()

oyImage_s * oyConversion_GetImage | ( | oyConversion_s * | conversion,
|  | uint32_t | flags
| ) |  |

Get a image copy at the desired position.

Function oyConversion_GetImage

Parameters

  [in,out] | conversion | conversion object
  [in] | flags | OY_INPUT or OY_OUTPUT

Returns
  the image

Version
  Oyranos: 0.1.10

Since
  2009/02/19 (Oyranos: 0.1.10)

Date
  2009/02/19

Referenced by oyImage_s::oyImage_FromFile().

## ◆ oyConversion_GetNode()

oyFilterNode_s * oyConversion_GetNode | ( | oyConversion_s * | conversion,
|  | uint32_t | flags
| ) |  |

Get the filter node copy.

Function oyConversion_GetNode

Parameters

  [in,out] | conversion | conversion object
  [in] | flags | OY_INPUT or OY_OUTPUT

Returns
  the filter node as defined by flags

Version
  Oyranos: 0.3.0

Since
  2011/03/27 (Oyranos: 0.3.0)

Date
  2011/03/29

Referenced by oyConversion_RunPixels().

## ◆ oyConversion_GetOnePixel()

int oyConversion_GetOnePixel | ( | oyConversion_s * | conversion,
|  | double | x,
|  | double | y,
|  | oyPixelAccess_s * | pixel_access
| ) |  |

Compute one pixel at the given position.

Function oyConversion_GetOnePixel

Parameters

  [in,out] | conversion | conversion object
  [in] | x | position x
  [in] | y | position y
  [in,out] | pixel_access | pixel iterator configuration

Returns
  -1 end; 0 on success; error > 1

Version
  Oyranos: 0.3.0

Since
  2008/07/14 (Oyranos: 0.1.8)

Date
  2011/04/11

References oyFilterNode_s::oyFilterNode_GetPlug(), and oyFilterPlug_s::oyFilterPlug_Release().

## ◆ oyConversion_New()

OYAPI oyConversion_s *OYEXPORT oyConversion_New | ( | oyObject_s | object | ) |

allocate a new Conversion object

Function oyConversion_New

References oyOBJECT_OBJECT_S.

Referenced by oyConversion_CreateBasicPixels(), oyImage_s::oyImage_FromFile(), and oyImage_s::oyImage_ToFile().

## ◆ oyConversion_Release()

OYAPI int OYEXPORT oyConversion_Release | ( | oyConversion_s ** | conversion | ) |

release and possibly deallocate a oyConversion_s object

Function oyConversion_Release

Parameters

  [in,out] | conversion | Conversion struct object

Examples:
  image2pdf.c.

References oyOBJECT_CONVERSION_S.

Referenced by oyConversion_CreateBasicPixels(), and oyImage_s::oyImage_ToFile().

## ◆ oyConversion_RunPixels()

int oyConversion_RunPixels | ( | oyConversion_s * | conversion,
|  | oyPixelAccess_s * | pixel_access
| ) |  |

Iterate over a conversion graph.

Function oyConversion_RunPixels

// use the output
oyConversion_RunPixels( context, NULL );
oyImage_s * image = oyConversion_GetImage( context, OY_OUTPUT );
// get the data and draw the image
for(i = 0; i < image->height; ++i)
{
image_data = oyImage_GetLineF(image)( image, i, &height, -1, &is_allocated );
// ...
if(is_allocated)
free( image_data );
}

Parameters

  [in,out] | conversion | conversion object
  [in,out] | pixel_access | optional pixel iterator configuration

Returns
  0 on success, else error

Version
  Oyranos: 0.1.10

Since
  2008/07/06 (Oyranos: 0.1.8)

Date
  2009/03/06

Examples:
  image2pdf.c, and tutorial1.c.

References oyConversion_GetNode(), oyOBJECT_CONVERSION_S, and oyOBJECT_RECTANGLE_S.

Referenced by oyImage_s::oyImage_ToFile().

## ◆ oyConversion_Set()

int oyConversion_Set | ( | oyConversion_s * | conversion,
|  | oyFilterNode_s * | input,
|  | oyFilterNode_s * | output
| ) |  |

Set input and output of a conversion graph.

Function oyConversion_Set

Parameters

  [in,out] | conversion | conversion object
  [in] | input | input node
  [in] | output | output node

Returns
  0 on success, else error

Version
  Oyranos: 0.1.10

Since
  2009/03/05 (Oyranos: 0.1.10)

Date
  2009/03/05

References oyOBJECT_CONVERSION_S.

Referenced by oyConversion_CreateBasicPixels(), oyImage_s::oyImage_FromFile(), and oyImage_s::oyImage_ToFile().

## ◆ oyConversion_ToText()

char * oyConversion_ToText | ( | oyConversion_s * | conversion,
|  | const char * | head_line,
|  | int | reserved,
|  | oyAlloc_f | allocateFunc
| ) |  |

Text description of a conversion graph.

Function oyConversion_ToText

Todo:
  Should this function generate XFORMS compatible output? How?

Parameters

  [in] | conversion | conversion object
  [in] | head_line | text for inclusion
  [in] | reserved | future format selector (dot, xml ...)
  [in] | allocateFunc | allocation function

Returns
  the graph description

Version
  Oyranos: 0.1.8

Since
  2008/10/04 (Oyranos: 0.1.8)

Date
  2009/03/05

References oyFilterGraph_s::oyFilterGraph_New(), oyFilterGraph_s::oyFilterGraph_Release(), oyFilterGraph_s::oyFilterGraph_SetFromNode(), oyFilterGraph_s::oyFilterGraph_ToText(), and oyOBJECT_CONVERSION_S.

## Field Documentation

## ◆ copy

oyStruct_Copy_f oyConversion_s::copy

Copy function.

## ◆ oy_

oyObject_s oyConversion_s::oy_

Oyranos internal object.

Features name and hash. Do not change during object life time.

## ◆ release

oyStruct_Release_f oyConversion_s::release

Release function.

## ◆ type_

const oyOBJECT_e oyConversion_s::type_

Type of object.

The struct type tells Oyranos how to interprete hidden fields.